// generated from file '../src/LV2/faust/gxtubetremelo.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)

#include "valve.h"

namespace gxtubetremelo {

class Dsp: public PluginLV2 {
private:
	uint32_t fSamplingFreq;
	int 	iVec0[2];
	int 	iConst0;
	double 	fConst1;
	double 	fConst2;
	double 	fConst3;
	double 	fConst4;
	double 	fConst5;
	double 	fConst6;
	double 	fConst7;
	double 	fConst8;
	double 	fVec1[2];
	double 	fRec2[2];
	double 	fVec2[2];
	double 	fRec5[2];
	double 	fRec4[2];
	double 	fConst9;
	double 	fRec3[2];
	FAUSTFLOAT 	fslider0;
	FAUSTFLOAT	*fslider0_;
	double 	fRec6[2];
	double 	fConst10;
	FAUSTFLOAT 	fslider1;
	FAUSTFLOAT	*fslider1_;
	FAUSTFLOAT 	fcheckbox0;
	FAUSTFLOAT	*fcheckbox0_;
	double 	fConst11;
	FAUSTFLOAT 	fslider2;
	FAUSTFLOAT	*fslider2_;
	double 	fRec10[2];
	double 	fRec9[2];
	double 	fRec8[2];
	double 	fConst12;
	int 	iRec12[2];
	int 	iRec11[2];
	double 	fRec7[2];
	double 	fRec1[2];
	double 	fRec0[2];
	void connect(uint32_t port,void* data);
	void clear_state_f();
	void init(uint32_t samplingFreq);
	void compute(int count, float *input0, float *output0);

	static void clear_state_f_static(PluginLV2*);
	static void init_static(uint32_t samplingFreq, PluginLV2*);
	static void compute_static(int count, float *input0, float *output0, PluginLV2*);
	static void del_instance(PluginLV2 *p);
	static void connect_static(uint32_t port,void* data, PluginLV2 *p);
public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginLV2() {
	version = PLUGINLV2_VERSION;
	id = "gxtubetremelo";
	name = N_("Tube Tremolo");
	mono_audio = compute_static;
	stereo_audio = 0;
	set_samplerate = init_static;
	activate_plugin = 0;
	connect_ports = connect_static;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<2; i++) iVec0[i] = 0;
	for (int i=0; i<2; i++) fVec1[i] = 0;
	for (int i=0; i<2; i++) fRec2[i] = 0;
	for (int i=0; i<2; i++) fVec2[i] = 0;
	for (int i=0; i<2; i++) fRec5[i] = 0;
	for (int i=0; i<2; i++) fRec4[i] = 0;
	for (int i=0; i<2; i++) fRec3[i] = 0;
	for (int i=0; i<2; i++) fRec6[i] = 0;
	for (int i=0; i<2; i++) fRec10[i] = 0;
	for (int i=0; i<2; i++) fRec9[i] = 0;
	for (int i=0; i<2; i++) fRec8[i] = 0;
	for (int i=0; i<2; i++) iRec12[i] = 0;
	for (int i=0; i<2; i++) iRec11[i] = 0;
	for (int i=0; i<2; i++) fRec7[i] = 0;
	for (int i=0; i<2; i++) fRec1[i] = 0;
	for (int i=0; i<2; i++) fRec0[i] = 0;
}

void Dsp::clear_state_f_static(PluginLV2 *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(uint32_t samplingFreq)
{
	fSamplingFreq = samplingFreq;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (1.0 / tan((97.38937226128358 / iConst0)));
	fConst2 = (1 + fConst1);
	fConst3 = (0 - ((1 - fConst1) / fConst2));
	fConst4 = (0.025 / fConst2);
	fConst5 = (1.0 / tan((6.5973445725385655 / iConst0)));
	fConst6 = (1 + fConst5);
	fConst7 = (0 - ((1 - fConst5) / fConst6));
	fConst8 = (1.0 / fConst6);
	fConst9 = (0 - fConst1);
	fConst10 = (1.0 / iConst0);
	fConst11 = (6.283185307179586 / iConst0);
	fConst12 = (0.5 * iConst0);
	clear_state_f();
}

void Dsp::init_static(uint32_t samplingFreq, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void always_inline Dsp::compute(int count, float *input0, float *output0)
{
#define fslider0 (*fslider0_)
#define fslider1 (*fslider1_)
#define fcheckbox0 (*fcheckbox0_)
#define fslider2 (*fslider2_)
	double 	fSlow0 = (0.0010000000000000009 * pow(10,(0.05 * fslider0)));
	double 	fSlow1 = fslider1;
	int 	iSlow2 = int(fcheckbox0);
	double 	fSlow3 = fslider2;
	double 	fSlow4 = (fConst11 * fSlow3);
	int 	iSlow5 = int((fConst12 / double(fSlow3)));
	double 	fSlow6 = (1.0 / iSlow5);
	for (int i=0; i<count; i++) {
		iVec0[0] = 1;
		double fTemp0 = (1e-15 + (0.015 * fRec1[1]));
		fVec1[0] = fTemp0;
		fRec2[0] = ((fConst7 * fRec2[1]) + (fConst8 * (fVec1[0] + fVec1[1])));
		double fTemp1 = (1e-15 + (0.015 * fRec4[1]));
		fVec2[0] = fTemp1;
		fRec5[0] = ((fConst7 * fRec5[1]) + (fConst8 * (fVec2[0] + fVec2[1])));
		fRec4[0] = (Ftube(TUBE_TABLE_12AX7_68k, (((double)input0[i] + fRec5[0]) - 1.204540999999999)) - 169.69726666666665);
		fRec3[0] = ((fConst3 * fRec3[1]) + (fConst4 * ((fConst1 * fRec4[0]) + (fConst9 * fRec4[1]))));
		fRec6[0] = ((0.999 * fRec6[1]) + fSlow0);
		double fTemp2 = (fRec7[1] * (1 - (fConst10 / (fConst10 + (0.06 * exp((0 - (2.4849066497880004 * fRec7[1]))))))));
		fRec10[0] = (fRec10[1] + (fSlow4 * (0 - fRec8[1])));
		fRec9[0] = ((1 + (fRec9[1] + (fSlow4 * fRec10[0]))) - iVec0[1]);
		fRec8[0] = fRec9[0];
		iRec12[0] = ((int((iRec12[1] > 0)))?((2 * (iRec11[1] < iSlow5)) - 1):(1 - (2 * (iRec11[1] > 0))));
		iRec11[0] = (iRec12[0] + iRec11[1]);
		fRec7[0] = (fTemp2 + (fConst10 * (pow((1 + (fSlow1 * (((iSlow2)?max(0, (0.5 * (1 + fRec8[0]))):(fSlow6 * iRec11[0])) - 1))),1.9) / (fConst10 + (0.06 * exp((0 - (2.4849066497880004 * fTemp2))))))));
		fRec1[0] = (Ftube(TUBE_TABLE_12AX7_250k, ((fRec2[0] + (2700 * ((fRec3[0] * fRec6[0]) / (2700 + exp((13.815510557964274 / log((2.718281828459045 + (8.551967507929417 * fRec7[0]))))))))) - 1.204284999999999)) - 169.71433333333334);
		fRec0[0] = ((fConst3 * fRec0[1]) + (fConst4 * ((fConst1 * fRec1[0]) + (fConst9 * fRec1[1]))));
		output0[i] = (FAUSTFLOAT)fRec0[0];
		// post processing
		fRec0[1] = fRec0[0];
		fRec1[1] = fRec1[0];
		fRec7[1] = fRec7[0];
		iRec11[1] = iRec11[0];
		iRec12[1] = iRec12[0];
		fRec8[1] = fRec8[0];
		fRec9[1] = fRec9[0];
		fRec10[1] = fRec10[0];
		fRec6[1] = fRec6[0];
		fRec3[1] = fRec3[0];
		fRec4[1] = fRec4[0];
		fRec5[1] = fRec5[0];
		fVec2[1] = fVec2[0];
		fRec2[1] = fRec2[0];
		fVec1[1] = fVec1[0];
		iVec0[1] = iVec0[0];
	}
#undef fslider0
#undef fslider1
#undef fcheckbox0
#undef fslider2
}

void __rt_func Dsp::compute_static(int count, float *input0, float *output0, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, output0);
}


void Dsp::connect(uint32_t port,void* data)
{
	switch ((PortIndex)port)
	{
	case GAIN: 
		fslider0_ = (float*)data; // , 0.0, -12.0, 12.0, 0.1 
		break;
	// static const value_pair fcheckbox0_values[] = {{"triangle"},{"sine"},{0}};
	case SINEWAVE: 
		fcheckbox0_ = (float*)data; // , 0.0, 0.0, 1.0, 1.0 
		break;
	case DEPTH: 
		fslider1_ = (float*)data; // , 0.5, 0.0, 1.0, 0.01 
		break;
	case SPEED: 
		fslider2_ = (float*)data; // , 5.0, 0.1, 2e+01, 0.1 
		break;
	default:
		break;
	}
}

void Dsp::connect_static(uint32_t port,void* data, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->connect(port, data);
}


PluginLV2 *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginLV2 *p)
{
	delete static_cast<Dsp*>(p);
}

/*
typedef enum
{
   GAIN, 
   SINEWAVE, 
   DEPTH, 
   SPEED, 
} PortIndex;
*/

} // end namespace gxtubetremelo
