// generated from file '../src/LV2/faust/tonestack_mesa_stereo.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)


namespace tonestack_mesa_stereo {

class Dsp: public PluginLV2 {
private:
	uint32_t fSamplingFreq;
	double 	fConst0;
	FAUSTFLOAT 	fslider0;
	FAUSTFLOAT	*fslider0_;
	FAUSTFLOAT 	fslider1;
	FAUSTFLOAT	*fslider1_;
	double 	fConst1;
	FAUSTFLOAT 	fslider2;
	FAUSTFLOAT	*fslider2_;
	double 	fConst2;
	double 	fRec0[4];
	double 	fRec1[4];
	void connect(uint32_t port,void* data);
	void clear_state_f();
	void init(uint32_t samplingFreq);
	void compute(int count, float *input0, float *input1, float *output0, float *output1);

	static void clear_state_f_static(PluginLV2*);
	static void init_static(uint32_t samplingFreq, PluginLV2*);
	static void compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginLV2*);
	static void del_instance(PluginLV2 *p);
	static void connect_static(uint32_t port,void* data, PluginLV2 *p);
public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginLV2() {
	version = PLUGINLV2_VERSION;
	id = "Mesa Boogie";
	name = N_("Mesa Boogie");
	mono_audio = 0;
	stereo_audio = compute_static;
	set_samplerate = init_static;
	activate_plugin = 0;
	connect_ports = connect_static;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<4; i++) fRec0[i] = 0;
	for (int i=0; i<4; i++) fRec1[i] = 0;
}

void Dsp::clear_state_f_static(PluginLV2 *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(uint32_t samplingFreq)
{
	fSamplingFreq = samplingFreq;
	fConst0 = (2 * double(min(192000, max(1, fSamplingFreq))));
	fConst1 = faustpower<2>(fConst0);
	fConst2 = (3 * fConst0);
	clear_state_f();
}

void Dsp::init_static(uint32_t samplingFreq, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void always_inline Dsp::compute(int count, float *input0, float *input1, float *output0, float *output1)
{
#define fslider0 (*fslider0_)
#define fslider1 (*fslider1_)
#define fslider2 (*fslider2_)
	double 	fSlow0 = fslider0;
	double 	fSlow1 = (0.001175 * fSlow0);
	double 	fSlow2 = exp((3.4 * (fslider1 - 1)));
	double 	fSlow3 = (0.0250625 * fSlow2);
	double 	fSlow4 = (fConst0 * (0.01726875 + (fSlow1 + fSlow3)));
	double 	fSlow5 = (2.9448437500000003e-06 * fSlow0);
	double 	fSlow6 = (((fSlow0 * (((2.9448437500000007e-05 * fSlow2) - 8.731718750000001e-06) - fSlow5)) + (0.00011998125000000002 * fSlow2)) + 1.2916875000000002e-05);
	double 	fSlow7 = ((2.5703125000000004e-09 * fSlow2) - (2.5703125000000003e-10 * fSlow0));
	double 	fSlow8 = (7.343750000000001e-09 * fSlow2);
	double 	fSlow9 = (7.343750000000001e-10 + ((fSlow0 * (fSlow7 - 4.773437500000001e-10)) + fSlow8));
	double 	fSlow10 = (fConst0 * fSlow9);
	double 	fSlow11 = (1.0 / (0 - (1 + (fSlow4 + (fConst1 * (fSlow6 + fSlow10))))));
	double 	fSlow12 = fslider2;
	double 	fSlow13 = ((fSlow3 + (fSlow1 + (6.25e-05 * fSlow12))) + 0.0025062500000000002);
	double 	fSlow14 = (fConst0 * (0 - fSlow13));
	double 	fSlow15 = ((((9.187500000000001e-07 * fSlow12) + (fSlow0 * (3.0182812500000004e-06 - fSlow5))) + (fSlow2 * (2.48125e-06 + (2.9448437500000007e-05 * fSlow0)))) + 2.48125e-07);
	double 	fSlow16 = ((fSlow0 * (2.5703125000000003e-10 + fSlow7)) + (fSlow12 * (fSlow8 + (7.343750000000001e-10 - (7.343750000000001e-10 * fSlow0)))));
	double 	fSlow17 = (fConst0 * fSlow16);
	double 	fSlow18 = (fSlow14 - (fConst1 * (fSlow15 + fSlow17)));
	double 	fSlow19 = (fConst2 * fSlow9);
	double 	fSlow20 = ((fConst1 * (fSlow6 + fSlow19)) - (3 + fSlow4));
	double 	fSlow21 = ((fSlow4 + (fConst1 * (fSlow6 - fSlow19))) - 3);
	double 	fSlow22 = ((fSlow4 + (fConst1 * (fSlow10 - fSlow6))) - 1);
	double 	fSlow23 = (fConst2 * fSlow16);
	double 	fSlow24 = (fSlow14 + (fConst1 * (fSlow15 + fSlow23)));
	double 	fSlow25 = (fConst0 * fSlow13);
	double 	fSlow26 = (fSlow25 + (fConst1 * (fSlow15 - fSlow23)));
	double 	fSlow27 = (fSlow25 + (fConst1 * (fSlow17 - fSlow15)));
	for (int i=0; i<count; i++) {
		fRec0[0] = ((double)input0[i] - (fSlow11 * (((fSlow20 * fRec0[1]) + (fSlow21 * fRec0[2])) + (fSlow22 * fRec0[3]))));
		output0[i] = (FAUSTFLOAT)(fSlow11 * ((((fSlow18 * fRec0[0]) + (fSlow24 * fRec0[1])) + (fSlow26 * fRec0[2])) + (fSlow27 * fRec0[3])));
		fRec1[0] = ((double)input1[i] - (fSlow11 * (((fSlow20 * fRec1[1]) + (fSlow21 * fRec1[2])) + (fSlow22 * fRec1[3]))));
		output1[i] = (FAUSTFLOAT)(fSlow11 * ((((fSlow18 * fRec1[0]) + (fSlow24 * fRec1[1])) + (fSlow26 * fRec1[2])) + (fSlow27 * fRec1[3])));
		// post processing
		for (int i=3; i>0; i--) fRec1[i] = fRec1[i-1];
		for (int i=3; i>0; i--) fRec0[i] = fRec0[i-1];
	}
#undef fslider0
#undef fslider1
#undef fslider2
}

void __rt_func Dsp::compute_static(int count, float *input0, float *input1, float *output0, float *output1, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, input1, output0, output1);
}


void Dsp::connect(uint32_t port,void* data)
{
	switch ((PortIndex)port)
	{
	case BASS: 
		fslider1_ = (float*)data; // , 0.5, 0.0, 1.0, 0.01 
		break;
	case MIDDLE: 
		fslider0_ = (float*)data; // , 0.5, 0.0, 1.0, 0.01 
		break;
	case TREBLE: 
		fslider2_ = (float*)data; // , 0.5, 0.0, 1.0, 0.01 
		break;
	default:
		break;
	}
}

void Dsp::connect_static(uint32_t port,void* data, PluginLV2 *p)
{
	static_cast<Dsp*>(p)->connect(port, data);
}


PluginLV2 *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginLV2 *p)
{
	delete static_cast<Dsp*>(p);
}

/*
typedef enum
{
   BASS, 
   MIDDLE, 
   TREBLE, 
} PortIndex;
*/

} // end namespace tonestack_mesa_stereo
