// generated from file '../src/faust/peak_eq.dsp' by dsp2cc:
// Code generated with Faust 0.9.46 (http://faust.grame.fr)


namespace peak_eq {

class Dsp: public PluginDef {
private:
	int fSamplingFreq;
	int 	iConst0;
	double 	fConst1;
	FAUSTFLOAT 	fslider0;
	FAUSTFLOAT 	fslider1;
	FAUSTFLOAT 	fslider2;
	FAUSTFLOAT 	fslider3;
	FAUSTFLOAT 	fslider4;
	double 	fConst2;
	double 	fConst3;
	FAUSTFLOAT 	fslider5;
	double 	fConst4;
	double 	fRec3[3];
	FAUSTFLOAT 	fslider6;
	FAUSTFLOAT 	fslider7;
	double 	fRec2[3];
	FAUSTFLOAT 	fslider8;
	FAUSTFLOAT 	fslider9;
	double 	fRec1[3];
	FAUSTFLOAT 	fslider10;
	FAUSTFLOAT 	fslider11;
	double 	fRec0[3];
	void clear_state_f();
	int load_ui_f(const UiBuilder& b, int form);
	void init(unsigned int samplingFreq);
	void compute(int count, float *input0, float *output0);
	int register_par(const ParamReg& reg);

	static void clear_state_f_static(PluginDef*);
	static int load_ui_f_static(const UiBuilder& b, int form);
	static void init_static(unsigned int samplingFreq, PluginDef*);
	static void compute_static(int count, float *input0, float *output0, PluginDef*);
	static int register_params_static(const ParamReg& reg);
	static void del_instance(PluginDef *p);
public:
	Dsp();
	~Dsp();
};



Dsp::Dsp()
	: PluginDef() {
	version = PLUGINDEF_VERSION;
	flags = 0;
	id = "eq";
	name = N_("Peak EQ");
	groups = 0;
	description = ""; // description (tooltip)
	category = N_("Tone control");       // category
	shortname = "";     // shortname
	mono_audio = compute_static;
	stereo_audio = 0;
	set_samplerate = init_static;
	activate_plugin = 0;
	register_params = register_params_static;
	load_ui = load_ui_f_static;
	clear_state = clear_state_f_static;
	delete_instance = del_instance;
}

Dsp::~Dsp() {
}

inline void Dsp::clear_state_f()
{
	for (int i=0; i<3; i++) fRec3[i] = 0;
	for (int i=0; i<3; i++) fRec2[i] = 0;
	for (int i=0; i<3; i++) fRec1[i] = 0;
	for (int i=0; i<3; i++) fRec0[i] = 0;
}

void Dsp::clear_state_f_static(PluginDef *p)
{
	static_cast<Dsp*>(p)->clear_state_f();
}

inline void Dsp::init(unsigned int samplingFreq)
{
	fSamplingFreq = samplingFreq;
	iConst0 = min(192000, max(1, fSamplingFreq));
	fConst1 = (3.141592653589793 / iConst0);
	fConst2 = double((1.0 / iConst0));
	fConst3 = (3.141592653589793 * fConst2);
	fConst4 = (6.283185307179586 * fConst2);
	clear_state_f();
}

void Dsp::init_static(unsigned int samplingFreq, PluginDef *p)
{
	static_cast<Dsp*>(p)->init(samplingFreq);
}

void always_inline Dsp::compute(int count, float *input0, float *output0)
{
	double 	fSlow0 = fslider0;
	double 	fSlow1 = tan((fConst1 * fSlow0));
	double 	fSlow2 = (2 * (1 - (1.0 / faustpower<2>(fSlow1))));
	double 	fSlow3 = fslider1;
	double 	fSlow4 = tan((fConst1 * fSlow3));
	double 	fSlow5 = (2 * (1 - (1.0 / faustpower<2>(fSlow4))));
	double 	fSlow6 = fslider2;
	double 	fSlow7 = tan((fConst1 * fSlow6));
	double 	fSlow8 = (2 * (1 - (1.0 / faustpower<2>(fSlow7))));
	double 	fSlow9 = fslider3;
	double 	fSlow10 = tan((fConst1 * fSlow9));
	double 	fSlow11 = (2 * (1 - (1.0 / faustpower<2>(fSlow10))));
	double 	fSlow12 = (1.0 / fSlow10);
	double 	fSlow13 = fslider4;
	int 	iSlow14 = int((fSlow13 > 0));
	double 	fSlow15 = fslider5;
	double 	fSlow16 = sin((fConst4 * fSlow9));
	double 	fSlow17 = (fConst3 * (fSlow15 / fSlow16));
	double 	fSlow18 = (fConst3 * ((fSlow15 * pow(10,(0.05 * fabs(fSlow13)))) / fSlow16));
	double 	fSlow19 = ((iSlow14)?fSlow17:fSlow18);
	double 	fSlow20 = (1 + (fSlow12 * (fSlow12 - fSlow19)));
	double 	fSlow21 = (1 + (fSlow12 * (fSlow19 + fSlow12)));
	double 	fSlow22 = ((iSlow14)?fSlow18:fSlow17);
	double 	fSlow23 = (1 + (fSlow12 * (fSlow22 + fSlow12)));
	double 	fSlow24 = (1 + (fSlow12 * (fSlow12 - fSlow22)));
	double 	fSlow25 = (1.0 / fSlow7);
	double 	fSlow26 = fslider6;
	int 	iSlow27 = int((fSlow26 > 0));
	double 	fSlow28 = fslider7;
	double 	fSlow29 = sin((fConst4 * fSlow6));
	double 	fSlow30 = (fConst3 * (fSlow28 / fSlow29));
	double 	fSlow31 = (fConst3 * ((fSlow28 * pow(10,(0.05 * fabs(fSlow26)))) / fSlow29));
	double 	fSlow32 = ((iSlow27)?fSlow30:fSlow31);
	double 	fSlow33 = (1 + (fSlow25 * (fSlow25 - fSlow32)));
	double 	fSlow34 = (1 + (fSlow25 * (fSlow32 + fSlow25)));
	double 	fSlow35 = ((iSlow27)?fSlow31:fSlow30);
	double 	fSlow36 = (1 + (fSlow25 * (fSlow35 + fSlow25)));
	double 	fSlow37 = (1 + (fSlow25 * (fSlow25 - fSlow35)));
	double 	fSlow38 = (1.0 / fSlow4);
	double 	fSlow39 = fslider8;
	int 	iSlow40 = int((fSlow39 > 0));
	double 	fSlow41 = fslider9;
	double 	fSlow42 = sin((fConst4 * fSlow3));
	double 	fSlow43 = (fConst3 * (fSlow41 / fSlow42));
	double 	fSlow44 = (fConst3 * ((fSlow41 * pow(10,(0.05 * fabs(fSlow39)))) / fSlow42));
	double 	fSlow45 = ((iSlow40)?fSlow43:fSlow44);
	double 	fSlow46 = (1 + (fSlow38 * (fSlow38 - fSlow45)));
	double 	fSlow47 = (1 + (fSlow38 * (fSlow45 + fSlow38)));
	double 	fSlow48 = ((iSlow40)?fSlow44:fSlow43);
	double 	fSlow49 = (1 + (fSlow38 * (fSlow48 + fSlow38)));
	double 	fSlow50 = (1 + (fSlow38 * (fSlow38 - fSlow48)));
	double 	fSlow51 = (1.0 / fSlow1);
	double 	fSlow52 = fslider10;
	int 	iSlow53 = int((fSlow52 > 0));
	double 	fSlow54 = fslider11;
	double 	fSlow55 = sin((fConst4 * fSlow0));
	double 	fSlow56 = (fConst3 * (fSlow54 / fSlow55));
	double 	fSlow57 = (fConst3 * ((fSlow54 * pow(10,(0.05 * fabs(fSlow52)))) / fSlow55));
	double 	fSlow58 = ((iSlow53)?fSlow56:fSlow57);
	double 	fSlow59 = (1 + (fSlow51 * (fSlow51 - fSlow58)));
	double 	fSlow60 = (1 + (fSlow51 * (fSlow58 + fSlow51)));
	double 	fSlow61 = ((iSlow53)?fSlow57:fSlow56);
	double 	fSlow62 = (1 + (fSlow51 * (fSlow61 + fSlow51)));
	double 	fSlow63 = (1 + (fSlow51 * (fSlow51 - fSlow61)));
	for (int i=0; i<count; i++) {
		double fTemp0 = (fSlow11 * fRec3[1]);
		fRec3[0] = ((double)input0[i] - (((fSlow20 * fRec3[2]) + fTemp0) / fSlow21));
		double fTemp1 = (fSlow8 * fRec2[1]);
		fRec2[0] = ((((fTemp0 + (fSlow23 * fRec3[0])) + (fSlow24 * fRec3[2])) / fSlow21) - (((fSlow33 * fRec2[2]) + fTemp1) / fSlow34));
		double fTemp2 = (fSlow5 * fRec1[1]);
		fRec1[0] = ((((fTemp1 + (fSlow36 * fRec2[0])) + (fSlow37 * fRec2[2])) / fSlow34) - (((fSlow46 * fRec1[2]) + fTemp2) / fSlow47));
		double fTemp3 = (fSlow2 * fRec0[1]);
		fRec0[0] = ((((fTemp2 + (fSlow49 * fRec1[0])) + (fSlow50 * fRec1[2])) / fSlow47) - (((fSlow59 * fRec0[2]) + fTemp3) / fSlow60));
		output0[i] = (FAUSTFLOAT)(((fTemp3 + (fSlow62 * fRec0[0])) + (fSlow63 * fRec0[2])) / fSlow60);
		// post processing
		fRec0[2] = fRec0[1]; fRec0[1] = fRec0[0];
		fRec1[2] = fRec1[1]; fRec1[1] = fRec1[0];
		fRec2[2] = fRec2[1]; fRec2[1] = fRec2[0];
		fRec3[2] = fRec3[1]; fRec3[1] = fRec3[0];
	}
}

void __rt_func Dsp::compute_static(int count, float *input0, float *output0, PluginDef *p)
{
	static_cast<Dsp*>(p)->compute(count, input0, output0);
}

int Dsp::register_par(const ParamReg& reg)
{
	reg.registerVar("eq.bandwidth1","","S",N_("bandwidth (hz)"),&fslider5, 41.0, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth2","","S",N_("bandwidth (hz)"),&fslider7, 2.2e+02, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth3","","S",N_("bandwidth (hz)"),&fslider9, 8.8e+02, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.bandwidth4","","S",N_("bandwidth (hz)"),&fslider11, 1.76e+03, 5.0, 2e+04, 1.0);
	reg.registerVar("eq.level1","","S",N_("gain (dB)"),&fslider4, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level2","","S",N_("gain (dB)"),&fslider6, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level3","","S",N_("gain (dB)"),&fslider8, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.level4","","S",N_("gain (dB)"),&fslider10, 0.0, -5e+01, 5e+01, 0.1);
	reg.registerVar("eq.peak1","","S",N_("frequency (hz)"),&fslider3, 1.1e+02, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak2","","S",N_("frequency (hz)"),&fslider2, 4.4e+02, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak3","","S",N_("frequency (hz)"),&fslider1, 1.76e+03, 2e+01, 2.2e+04, 1.0);
	reg.registerVar("eq.peak4","","S",N_("frequency (hz)"),&fslider0, 3.52e+03, 2e+01, 2.2e+04, 1.0);
	return 0;
}

int Dsp::register_params_static(const ParamReg& reg)
{
	return static_cast<Dsp*>(reg.plugin)->register_par(reg);
}

inline int Dsp::load_ui_f(const UiBuilder& b, int form)
{
    if (form & UI_FORM_STACK) {
#define PARAM(p) ("eq" "." p)
b.openHorizontalhideBox("");
b.closeBox();
b.openHorizontalTableBox("");
{
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level1"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak1"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth1"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level2"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak2"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth2"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level3"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak3"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth3"), _("bandwidth"));
    }
    b.closeBox();
    b.openVerticalBox1("");
    {
	b.create_small_rackknob(PARAM("level4"), _("peak"));
	b.insertSpacer();
	b.create_spin_value(PARAM("peak4"), _("frequency"));
	b.insertSpacer();
	b.create_spin_value(PARAM("bandwidth4"), _("bandwidth"));
    }
    b.closeBox();
}
b.closeBox();

#undef PARAM
        return 0;
    }
	return -1;
}

int Dsp::load_ui_f_static(const UiBuilder& b, int form)
{
	return static_cast<Dsp*>(b.plugin)->load_ui_f(b, form);
}
PluginDef *plugin() {
	return new Dsp();
}

void Dsp::del_instance(PluginDef *p)
{
	delete static_cast<Dsp*>(p);
}

} // end namespace peak_eq
